﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace _1_Praktikum
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void Ellipse_MouseUp(object sender, MouseButtonEventArgs e)
        {
            // Am Ende des Semesters wird man diese Aufgabe hoffentlich viel eleganter lösen!

            Ellipse[] ellipsen = { Ellipse0, Ellipse1, Ellipse2, Ellipse3, Ellipse4, Ellipse5, Ellipse6, Ellipse7, Ellipse8 };

            // Bestimme Nummer der Ellipse
            int welcheEllipse = -1;
            for (int i = 0; i < 9; i++)
            {
                if (sender == ellipsen[i])
                {
                    welcheEllipse = i;
                    break;
                }
            }

            if (ellipsen[welcheEllipse].Fill == Brushes.Blue || ellipsen[welcheEllipse].Fill == Brushes.Red)
            {
                return; // Feld war schon besetzt; wir machen nichts
            }
            ellipsen[welcheEllipse].Fill = Brushes.Red;

            // Hat der Mensch gewonnen?
            int[,] gewinn = { { 0, 1, 2 }, { 3, 4, 5 }, { 6, 7, 8 }, { 0, 3, 6 }, { 1, 4, 7 }, { 2, 5, 8 }, { 0, 4, 8 }, { 2, 4, 6 } };
            for (int j = 0; j < 8; j++)
            {
                bool drei = true;
                for (int k = 0; k < 3; k++)
                {
                    if (ellipsen[gewinn[j, k]].Fill != Brushes.Red)
                    {
                        drei = false;
                        break;
                    }
                }

                if (drei)
                {
                    MessageBox.Show("Mensch gewinnt!");
                    for (int i = 0; i < 9; i++)
                    {
                        ellipsen[i].Fill = Brushes.White;
                    }
                    return;
                }
            }

            // Ungeschickte Strategie für den Computer: Setze auf den ersten freien Platz.
            for (int i = 0; i < dasGrid.Children.Count; i++)
            {
                if (ellipsen[i].Fill == Brushes.Blue || ellipsen[i].Fill == Brushes.Red)
                {
                    continue;
                }
                ellipsen[i].Fill = Brushes.Blue;
                break;
            }

            // Hat der Rechner gewonnen?
            for (int j = 0; j < 8; j++)
            {
                bool drei = true;
                for (int k = 0; k < 3; k++)
                {
                    if (ellipsen[gewinn[j, k]].Fill != Brushes.Blue)
                    {
                        drei = false;
                        break;
                    }
                }

                if (drei)
                {
                    MessageBox.Show("Rechner gewinnt!");
                    for (int i = 0; i < 9; i++)
                    {
                        ellipsen[i].Fill = Brushes.White;
                    }
                    return;
                }
            }
        }
    }
}
